﻿'-----------------------------------------------
'TUSB-PIO用ドライバアクセス用API
'Visual Basic 標準モジュール
'
'2013_10_23　株式会社タートル工業
'Copyright (C) 2013 Turtle Industry Co.,Ltd.
'-----------------------------------------------
Option Strict Off
Option Explicit On

Imports System.Runtime.InteropServices

Module TUSBPIO
    'API関数宣言
    <DllImport("TUSBPIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbpio_Device_Open( _
                                ByVal id As Short) _
                            As Short
    End Function
    <DllImport("TUSBPIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Sub Tusbpio_Device_Close( _
                                ByVal id As Short)
    End Sub
    <DllImport("TUSBPIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbpio_Dev1_Write( _
                                ByVal id As Short, _
                                ByVal addr As Byte, _
                                ByVal dat As Byte) _
                            As Short
    End Function
    <DllImport("TUSBPIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbpio_Dev2_Write( _
                                ByVal id As Short, _
                                ByVal addr As Byte, _
                                ByVal dat As Byte) _
                            As Short
    End Function
    <DllImport("TUSBPIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbpio_Dev1_Read( _
                                ByVal id As Short, _
                                ByVal addr As Byte, _
                                ByRef dat As Byte) _
                            As Short
    End Function
    <DllImport("TUSBPIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbpio_Dev2_Read( _
                                ByVal id As Short, _
                                ByVal addr As Byte, _
                                ByRef dat As Byte) _
                            As Short
    End Function

    'エラーメッセージ出力(オープン関数)
    Function Tusbpio_GetErrMessage1(ByVal retcode As Short) As String
        Select Case retcode
            Case 0
                Return "正常終了しました"
            Case 1
                Return "ID番号が不正です"
            Case 3
                Return "すでにデバイスはオープンされています"
            Case 4
                Return "接続されている台数が多すぎます"
            Case 5
                Return "オープンできませんでした"
            Case 6
                Return "デバイスがみつかりません"
            Case Else
                Return "不明なエラーです"
        End Select
    End Function
    'エラーメッセージ出力(その他の関数)
    Function Tusbpio_GetErrMessage2(ByVal retcode As Short) As String
        Select Case retcode
            Case 0
                Return "正常終了しました"
            Case 1
                Return "オープンされていません"
            Case 2
                Return "失敗しました"
            Case Else
                Return "不明なエラーです"
        End Select
    End Function
End Module
