﻿Public Class Form1

    Private DevId As Short
    Private ChangeLock As Boolean = True 'このビットがtrueの時はビット出力設定しない

    Private Sub Control_Enable(state As Boolean)
        DevClose.Enabled = state
        DevOpen.Enabled = Not state
        IDNUM.Enabled = Not state
        Dev1SetBtn.Enabled = state
        Dev2SetBtn.Enabled = state
        ChangeLock = Not state
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        '***フォームの表示開始時の初期化処理***
        Control_Enable(False) '***
        IDNUM.SelectedIndex = 0 '***初期選択IDを0にする
        Dev1PortASelIn.Checked = True
        Dev1PortBSelIn.Checked = True
        Dev1PortCLSelIn.Checked = True
        Dev1PortCHSelIn.Checked = True
        Dev2PortASelIn.Checked = True
        Dev2PortBSelIn.Checked = True
        Dev2PortCLSelIn.Checked = True
        Dev2PortCHSelIn.Checked = True
    End Sub

    Private Sub Form1_FormClosed(sender As System.Object, e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        '***アプリケーション終了時の処理
        If DevClose.Enabled Then
            Tusbpio_Device_Close(DevId) '***デバイスクローズ
        End If
    End Sub

    Private Sub DevOpen_Click(sender As System.Object, e As System.EventArgs) Handles DevOpen.Click
        Dim RetCode As Short

        '***デバイスのオープン***
        DevId = IDNUM.SelectedIndex
        Retcode = Tusbpio_Device_Open(DevId)
        If (Retcode = 0) Then
            Control_Enable(True) '***各機能ボタンを有効にする
            Timer1.Interval = 300 'タイマーインターバル
            Timer1.Enabled = True 'タイマー開始
        Else
            MessageBox.Show(Tusbpio_GetErrMessage1(RetCode)) '***オープンに失敗した場合
        End If
    End Sub

    Private Sub DevClose_Click(sender As System.Object, e As System.EventArgs) Handles DevClose.Click
        '***デバイスのクローズ***
        Timer1.Enabled = False 'タイマー停止
        Tusbpio_Device_Close(DevId) '***デバイスクローズ
        Control_Enable(False) '***ボタンの有効無効切り替え
    End Sub

    Private Function GetLampImage(bitmap As Byte, bit As Byte) As System.Drawing.Image
        Dim BitMask As Byte
        BitMask = 2 ^ bit
        Return IIf((bitmap And BitMask) = 0, ImageList1.Images(1), ImageList1.Images(0))
    End Function

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        Dim RetCode As Short
        Dim PortState(1, 2) As Byte
        Dim port As Byte

        'Device 1からのデータの取得
        For port = 0 To 2
            RetCode = Tusbpio_Dev1_Read(DevId, port, PortState(0, port))
            If RetCode <> 0 Then
                Timer1.Enabled = False
                MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
                Exit Sub
            End If
        Next
        'Device 2からのデータの取得
        For port = 0 To 2
            RetCode = Tusbpio_Dev2_Read(DevId, port, PortState(1, port))
            If RetCode <> 0 Then
                Timer1.Enabled = False
                MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
                Exit Sub
            End If
        Next

        'Device1 PortA
        Dev1PortA_I0.Image = GetLampImage(PortState(0, 0), 0)
        Dev1PortA_I1.Image = GetLampImage(PortState(0, 0), 1)
        Dev1PortA_I2.Image = GetLampImage(PortState(0, 0), 2)
        Dev1PortA_I3.Image = GetLampImage(PortState(0, 0), 3)
        Dev1PortA_I4.Image = GetLampImage(PortState(0, 0), 4)
        Dev1PortA_I5.Image = GetLampImage(PortState(0, 0), 5)
        Dev1PortA_I6.Image = GetLampImage(PortState(0, 0), 6)
        Dev1PortA_I7.Image = GetLampImage(PortState(0, 0), 7)
        'Device1 PortB
        Dev1PortB_I0.Image = GetLampImage(PortState(0, 1), 0)
        Dev1PortB_I1.Image = GetLampImage(PortState(0, 1), 1)
        Dev1PortB_I2.Image = GetLampImage(PortState(0, 1), 2)
        Dev1PortB_I3.Image = GetLampImage(PortState(0, 1), 3)
        Dev1PortB_I4.Image = GetLampImage(PortState(0, 1), 4)
        Dev1PortB_I5.Image = GetLampImage(PortState(0, 1), 5)
        Dev1PortB_I6.Image = GetLampImage(PortState(0, 1), 6)
        Dev1PortB_I7.Image = GetLampImage(PortState(0, 1), 7)
        'Device1 PortC
        Dev1PortC_I0.Image = GetLampImage(PortState(0, 2), 0)
        Dev1PortC_I1.Image = GetLampImage(PortState(0, 2), 1)
        Dev1PortC_I2.Image = GetLampImage(PortState(0, 2), 2)
        Dev1PortC_I3.Image = GetLampImage(PortState(0, 2), 3)
        Dev1PortC_I4.Image = GetLampImage(PortState(0, 2), 4)
        Dev1PortC_I5.Image = GetLampImage(PortState(0, 2), 5)
        Dev1PortC_I6.Image = GetLampImage(PortState(0, 2), 6)
        Dev1PortC_I7.Image = GetLampImage(PortState(0, 2), 7)
        'Device2 PortA
        Dev2PortA_I0.Image = GetLampImage(PortState(1, 0), 0)
        Dev2PortA_I1.Image = GetLampImage(PortState(1, 0), 1)
        Dev2PortA_I2.Image = GetLampImage(PortState(1, 0), 2)
        Dev2PortA_I3.Image = GetLampImage(PortState(1, 0), 3)
        Dev2PortA_I4.Image = GetLampImage(PortState(1, 0), 4)
        Dev2PortA_I5.Image = GetLampImage(PortState(1, 0), 5)
        Dev2PortA_I6.Image = GetLampImage(PortState(1, 0), 6)
        Dev2PortA_I7.Image = GetLampImage(PortState(1, 0), 7)
        'Device2 PortB
        Dev2PortB_I0.Image = GetLampImage(PortState(1, 1), 0)
        Dev2PortB_I1.Image = GetLampImage(PortState(1, 1), 1)
        Dev2PortB_I2.Image = GetLampImage(PortState(1, 1), 2)
        Dev2PortB_I3.Image = GetLampImage(PortState(1, 1), 3)
        Dev2PortB_I4.Image = GetLampImage(PortState(1, 1), 4)
        Dev2PortB_I5.Image = GetLampImage(PortState(1, 1), 5)
        Dev2PortB_I6.Image = GetLampImage(PortState(1, 1), 6)
        Dev2PortB_I7.Image = GetLampImage(PortState(1, 1), 7)
        'Device2 PortC
        Dev2PortC_I0.Image = GetLampImage(PortState(1, 2), 0)
        Dev2PortC_I1.Image = GetLampImage(PortState(1, 2), 1)
        Dev2PortC_I2.Image = GetLampImage(PortState(1, 2), 2)
        Dev2PortC_I3.Image = GetLampImage(PortState(1, 2), 3)
        Dev2PortC_I4.Image = GetLampImage(PortState(1, 2), 4)
        Dev2PortC_I5.Image = GetLampImage(PortState(1, 2), 5)
        Dev2PortC_I6.Image = GetLampImage(PortState(1, 2), 6)
        Dev2PortC_I7.Image = GetLampImage(PortState(1, 2), 7)
    End Sub

    Private Sub Dev1SetBtn_Click(sender As System.Object, e As System.EventArgs) Handles Dev1SetBtn.Click
        Dim RetCode As Short
        Dim ModeBitmap As Byte

        ModeBitmap = &H80 'モード設定 mode 0

        'Dev1 PortA 入出力方向
        ModeBitmap = ModeBitmap Or IIf(Dev1PortASelIn.Checked, &H10, 0) '第4ビットを1

        'Dev1 PortB 入出力方向
        ModeBitmap = ModeBitmap Or IIf(Dev1PortBSelIn.Checked, &H2, 0) '第1ビットを1

        'Dev1 PortC 下位　入出力方向
        ModeBitmap = ModeBitmap Or IIf(Dev1PortCLSelIn.Checked, &H1, 0) '第0ビットを1

        'dev1 PortC 上位　入出力方向
        ModeBitmap = ModeBitmap Or IIf(Dev1PortCHSelIn.Checked, &H8, 0) '第3ビットを1

        RetCode = Tusbpio_Dev1_Write(DevId, 3, ModeBitmap)
        If RetCode <> 0 Then
            MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
        End If

        'モードを設定すると出力ビットパターンが初期化される
        ChangeLock = True
        Dev1PortA_O0.Checked = False
        Dev1PortA_O1.Checked = False
        Dev1PortA_O2.Checked = False
        Dev1PortA_O3.Checked = False
        Dev1PortA_O4.Checked = False
        Dev1PortA_O5.Checked = False
        Dev1PortA_O6.Checked = False
        Dev1PortA_O7.Checked = False
        Dev1PortB_O0.Checked = False
        Dev1PortB_O1.Checked = False
        Dev1PortB_O2.Checked = False
        Dev1PortB_O3.Checked = False
        Dev1PortB_O4.Checked = False
        Dev1PortB_O5.Checked = False
        Dev1PortB_O6.Checked = False
        Dev1PortB_O7.Checked = False
        Dev1PortC_O0.Checked = False
        Dev1PortC_O1.Checked = False
        Dev1PortC_O2.Checked = False
        Dev1PortC_O3.Checked = False
        Dev1PortC_O4.Checked = False
        Dev1PortC_O5.Checked = False
        Dev1PortC_O6.Checked = False
        Dev1PortC_O7.Checked = False
        ChangeLock = False
    End Sub

    Private Sub Dev2SetBtn_Click(sender As System.Object, e As System.EventArgs) Handles Dev2SetBtn.Click
        Dim RetCode As Short
        Dim ModeBitmap As Byte

        ModeBitmap = &H80 'モード設定 mode 0

        'Dev2 PortA 入出力方向
        ModeBitmap = ModeBitmap Or IIf(Dev2PortASelIn.Checked, &H10, 0) '第4ビットを1

        'Dev1 PortB 入出力方向
        ModeBitmap = ModeBitmap Or IIf(Dev2PortBSelIn.Checked, &H2, 0) '第1ビットを1

        'Dev1 PortC 下位　入出力方向
        ModeBitmap = ModeBitmap Or IIf(Dev2PortCLSelIn.Checked, &H1, 0) '第0ビットを1

        'dev1 PortC 上位　入出力方向
        ModeBitmap = ModeBitmap Or IIf(Dev2PortCHSelIn.Checked, &H8, 0) '第3ビットを1

        RetCode = Tusbpio_Dev2_Write(DevId, 3, ModeBitmap)
        If RetCode <> 0 Then
            MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
        End If

        'モードを設定すると出力ビットパターンが初期化される
        ChangeLock = True
        Dev2PortA_O0.Checked = False
        Dev2PortA_O1.Checked = False
        Dev2PortA_O2.Checked = False
        Dev2PortA_O3.Checked = False
        Dev2PortA_O4.Checked = False
        Dev2PortA_O5.Checked = False
        Dev2PortA_O6.Checked = False
        Dev2PortA_O7.Checked = False
        Dev2PortB_O0.Checked = False
        Dev2PortB_O1.Checked = False
        Dev2PortB_O2.Checked = False
        Dev2PortB_O3.Checked = False
        Dev2PortB_O4.Checked = False
        Dev2PortB_O5.Checked = False
        Dev2PortB_O6.Checked = False
        Dev2PortB_O7.Checked = False
        Dev2PortC_O0.Checked = False
        Dev2PortC_O1.Checked = False
        Dev2PortC_O2.Checked = False
        Dev2PortC_O3.Checked = False
        Dev2PortC_O4.Checked = False
        Dev2PortC_O5.Checked = False
        Dev2PortC_O6.Checked = False
        Dev2PortC_O7.Checked = False
        ChangeLock = False
    End Sub

    Private Sub Dev1PortA_O_Changed(sender As System.Object, e As System.EventArgs) Handles Dev1PortA_O0.CheckedChanged, Dev1PortA_O7.CheckedChanged, Dev1PortA_O6.CheckedChanged, Dev1PortA_O5.CheckedChanged, Dev1PortA_O4.CheckedChanged, Dev1PortA_O3.CheckedChanged, Dev1PortA_O2.CheckedChanged, Dev1PortA_O1.CheckedChanged
        Dim RetCode As Short
        Dim Bitmap As Byte = 0

        If Not ChangeLock Then
            Bitmap = Bitmap Or IIf(Dev1PortA_O0.Checked, &H1, 0)
            Bitmap = Bitmap Or IIf(Dev1PortA_O1.Checked, &H2, 0)
            Bitmap = Bitmap Or IIf(Dev1PortA_O2.Checked, &H4, 0)
            Bitmap = Bitmap Or IIf(Dev1PortA_O3.Checked, &H8, 0)
            Bitmap = Bitmap Or IIf(Dev1PortA_O4.Checked, &H10, 0)
            Bitmap = Bitmap Or IIf(Dev1PortA_O5.Checked, &H20, 0)
            Bitmap = Bitmap Or IIf(Dev1PortA_O6.Checked, &H40, 0)
            Bitmap = Bitmap Or IIf(Dev1PortA_O7.Checked, &H80, 0)

            RetCode = Tusbpio_Dev1_Write(DevId, 0, Bitmap)
            If RetCode <> 0 Then
                MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
            End If
        End If

    End Sub

    Private Sub Dev1PortB_O_Changed(sender As System.Object, e As System.EventArgs) Handles Dev1PortB_O7.CheckedChanged, Dev1PortB_O6.CheckedChanged, Dev1PortB_O5.CheckedChanged, Dev1PortB_O4.CheckedChanged, Dev1PortB_O3.CheckedChanged, Dev1PortB_O2.CheckedChanged, Dev1PortB_O1.CheckedChanged, Dev1PortB_O0.CheckedChanged
        Dim RetCode As Short
        Dim Bitmap As Byte = 0

        If Not ChangeLock Then
            Bitmap = Bitmap Or IIf(Dev1PortB_O0.Checked, &H1, 0)
            Bitmap = Bitmap Or IIf(Dev1PortB_O1.Checked, &H2, 0)
            Bitmap = Bitmap Or IIf(Dev1PortB_O2.Checked, &H4, 0)
            Bitmap = Bitmap Or IIf(Dev1PortB_O3.Checked, &H8, 0)
            Bitmap = Bitmap Or IIf(Dev1PortB_O4.Checked, &H10, 0)
            Bitmap = Bitmap Or IIf(Dev1PortB_O5.Checked, &H20, 0)
            Bitmap = Bitmap Or IIf(Dev1PortB_O6.Checked, &H40, 0)
            Bitmap = Bitmap Or IIf(Dev1PortB_O7.Checked, &H80, 0)

            RetCode = Tusbpio_Dev1_Write(DevId, 1, Bitmap)
            If RetCode <> 0 Then
                MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
            End If
        End If

    End Sub

    Private Sub Dev1PortC_O_Changed(sender As System.Object, e As System.EventArgs) Handles Dev1PortC_O7.CheckedChanged, Dev1PortC_O6.CheckedChanged, Dev1PortC_O5.CheckedChanged, Dev1PortC_O4.CheckedChanged, Dev1PortC_O3.CheckedChanged, Dev1PortC_O2.CheckedChanged, Dev1PortC_O1.CheckedChanged, Dev1PortC_O0.CheckedChanged
        Dim RetCode As Short
        Dim Bitmap As Byte = 0

        If Not ChangeLock Then
            Bitmap = Bitmap Or IIf(Dev1PortC_O0.Checked, &H1, 0)
            Bitmap = Bitmap Or IIf(Dev1PortC_O1.Checked, &H2, 0)
            Bitmap = Bitmap Or IIf(Dev1PortC_O2.Checked, &H4, 0)
            Bitmap = Bitmap Or IIf(Dev1PortC_O3.Checked, &H8, 0)
            Bitmap = Bitmap Or IIf(Dev1PortC_O4.Checked, &H10, 0)
            Bitmap = Bitmap Or IIf(Dev1PortC_O5.Checked, &H20, 0)
            Bitmap = Bitmap Or IIf(Dev1PortC_O6.Checked, &H40, 0)
            Bitmap = Bitmap Or IIf(Dev1PortC_O7.Checked, &H80, 0)

            RetCode = Tusbpio_Dev1_Write(DevId, 2, Bitmap)
            If RetCode <> 0 Then
                MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
            End If
        End If

    End Sub

    Private Sub Dev2PortA_O_Changed(sender As System.Object, e As System.EventArgs) Handles Dev2PortA_O7.CheckedChanged, Dev2PortA_O6.CheckedChanged, Dev2PortA_O5.CheckedChanged, Dev2PortA_O4.CheckedChanged, Dev2PortA_O3.CheckedChanged, Dev2PortA_O2.CheckedChanged, Dev2PortA_O1.CheckedChanged, Dev2PortA_O0.CheckedChanged
        Dim RetCode As Short
        Dim Bitmap As Byte = 0

        If Not ChangeLock Then
            Bitmap = Bitmap Or IIf(Dev2PortA_O0.Checked, &H1, 0)
            Bitmap = Bitmap Or IIf(Dev2PortA_O1.Checked, &H2, 0)
            Bitmap = Bitmap Or IIf(Dev2PortA_O2.Checked, &H4, 0)
            Bitmap = Bitmap Or IIf(Dev2PortA_O3.Checked, &H8, 0)
            Bitmap = Bitmap Or IIf(Dev2PortA_O4.Checked, &H10, 0)
            Bitmap = Bitmap Or IIf(Dev2PortA_O5.Checked, &H20, 0)
            Bitmap = Bitmap Or IIf(Dev2PortA_O6.Checked, &H40, 0)
            Bitmap = Bitmap Or IIf(Dev2PortA_O7.Checked, &H80, 0)

            RetCode = Tusbpio_Dev2_Write(DevId, 0, Bitmap)
            If RetCode <> 0 Then
                MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
            End If
        End If

    End Sub

    Private Sub Dev2PortB_O_Changed(sender As System.Object, e As System.EventArgs) Handles Dev2PortB_O7.CheckedChanged, Dev2PortB_O6.CheckedChanged, Dev2PortB_O5.CheckedChanged, Dev2PortB_O4.CheckedChanged, Dev2PortB_O3.CheckedChanged, Dev2PortB_O2.CheckedChanged, Dev2PortB_O1.CheckedChanged, Dev2PortB_O0.CheckedChanged
        Dim RetCode As Short
        Dim Bitmap As Byte = 0

        If Not ChangeLock Then
            Bitmap = Bitmap Or IIf(Dev2PortB_O0.Checked, &H1, 0)
            Bitmap = Bitmap Or IIf(Dev2PortB_O1.Checked, &H2, 0)
            Bitmap = Bitmap Or IIf(Dev2PortB_O2.Checked, &H4, 0)
            Bitmap = Bitmap Or IIf(Dev2PortB_O3.Checked, &H8, 0)
            Bitmap = Bitmap Or IIf(Dev2PortB_O4.Checked, &H10, 0)
            Bitmap = Bitmap Or IIf(Dev2PortB_O5.Checked, &H20, 0)
            Bitmap = Bitmap Or IIf(Dev2PortB_O6.Checked, &H40, 0)
            Bitmap = Bitmap Or IIf(Dev2PortB_O7.Checked, &H80, 0)

            RetCode = Tusbpio_Dev2_Write(DevId, 1, Bitmap)
            If RetCode <> 0 Then
                MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
            End If
        End If

    End Sub

    Private Sub Dev2PortC_O_Changed(sender As System.Object, e As System.EventArgs) Handles Dev2PortC_O7.CheckedChanged, Dev2PortC_O6.CheckedChanged, Dev2PortC_O5.CheckedChanged, Dev2PortC_O4.CheckedChanged, Dev2PortC_O3.CheckedChanged, Dev2PortC_O2.CheckedChanged, Dev2PortC_O1.CheckedChanged, Dev2PortC_O0.CheckedChanged
        Dim RetCode As Short
        Dim Bitmap As Byte = 0

        If Not ChangeLock Then
            Bitmap = Bitmap Or IIf(Dev2PortC_O0.Checked, &H1, 0)
            Bitmap = Bitmap Or IIf(Dev2PortC_O1.Checked, &H2, 0)
            Bitmap = Bitmap Or IIf(Dev2PortC_O2.Checked, &H4, 0)
            Bitmap = Bitmap Or IIf(Dev2PortC_O3.Checked, &H8, 0)
            Bitmap = Bitmap Or IIf(Dev2PortC_O4.Checked, &H10, 0)
            Bitmap = Bitmap Or IIf(Dev2PortC_O5.Checked, &H20, 0)
            Bitmap = Bitmap Or IIf(Dev2PortC_O6.Checked, &H40, 0)
            Bitmap = Bitmap Or IIf(Dev2PortC_O7.Checked, &H80, 0)

            RetCode = Tusbpio_Dev2_Write(DevId, 2, Bitmap)
            If RetCode <> 0 Then
                MessageBox.Show(Tusbpio_GetErrMessage2(RetCode))
            End If
        End If
    End Sub
End Class
